//WR Ansteuerung mittels < momentan nur für WR1

// Bibliotheken
#include <Wire.h>
#include <Adafruit_ADS1015.h>
#include <PID_v1.h>
//#include <OneWire.h>
//#include <DallasTemperature.h>
//#include <SoftwareSerial.h>
#include <SendOnlySoftwareSerial.h>

//Software Serial
//SoftwareSerial mySerial(10, 11); // RX, TX
SendOnlySoftwareSerial mySerial1 (10);  //Pin kaputt
SendOnlySoftwareSerial mySerial2 (22);
// Pins Arduino Mega
#define MAX485_Modbus 7 //früher (vor Rotary Encoder) 3
#define MAX485_WR 6 //früher (vor Rotary Encoder) 2 //
#define PWM_Heizstab 5 
#define MOSFET_WR1 53
#define MOSFET_WR2 45 //Relais_Heizstab ein
#define MOSFET_WR3 43
#define MOSFET_Luefter 51
#define Relais_Heizstab 33
#define LR_Multiplexer 52
#define Temp_sensor 49
#define ONE_WIRE_BUS 49
#define TEMPERATURE_PRECISION 9


// Pins ADS1115
#define ADS_Batteriespannung 0
#define ADS_Stromsensor 1
#define ADS_Schaltschrank 2
#define ADS_Boiler 3

// Messwerte Zähler
float power;
float Netz_Bezug;
float Netz_Einspeisung;
float PV_Leistung;
float PV_Einspeisung;

// Sollwert WR
int P_WR_soll;
float I_WR_soll;
int taster = 24; // Inputpin für Schalter Volleinspeisung ja/nein
int tasterstatus = 0; // Abfrage Taster für Volleinspeisung


// Messwerte Laderegler
long u_bat_LR1;
long u_bat_LR2;
long PV_i_LR1;
long PV_i_LR2;
long PV_Power_LR1;
long PV_Power_LR2;
long yield_today_LR1;
long yield_today_LR2;
long yield_total_LR1;
long yield_total_LR2;
byte CS_LR1;
byte CS_LR2;
byte ERR_LR1;
byte ERR_LR2;

// Summen Laderegler
long PV_i_LR1_2;
long PPV_LR1_2;
long yield_total_LR1_2;

//Messwerte Temperatur
float tempSchaltschrank;
float tempBoiler;

// Variablendeklaration Strom- Spannungslogging
bool bat_leer = 0;
bool bat_voll = 0;

// BMS Daten auslesen
long u_bat = 0; // Spannungsmessung vorher float
long i_bat = 0; // Stromsensor vorher float
float soc;							//Variable speichert Ladezustand Akku ein
String inputString_BMS = "";         // a string to hold incoming data
boolean stringComplete = false;  // whether the string is complete

// Heizstab steuern
bool heizstab_ein = 0;


// PID Regler für Heizstab
// Define Variables we'll be connecting to
double Setpoint, Input, Heizstab_soll;
double kP = 0.025;//          0.01/0.1///////0.5;//0.075;//0.155;//2
//0.01 Regelgröße zw. 0 und3 %
//0.05 Regelgröße zw. 0 und 255 unschön
//0.025 Regelgröße zw. 0 und 55 alles harte Flanken, die wieder auf 0 zurück gehen
double Ki = 0;//5
double Kd = 0;//1
// double u_bat_LR2; // war vorher "long" geht das, dass diese Variable ein double wird?
// double Heizstab_soll = 0; // war vorher "int" geht das, dass diese Variable ein double wird?


// ADS1115
Adafruit_ADS1115 ads;  /* Use this for the 16-bit version */

// PID
//Specify the links and initial tuning parameters
//Input: The variable we're trying to control (double) --> i_bat
//Output: The variable that will be adjusted by the pid (double) --> Heizstab_soll
//Setpoint: The value we want to Input to maintain (double) --> i_bat_soll = Restladestrom Akku
//Kp, Ki, Kd: Tuning Parameters. these affect how the pid will chage the output. (double>=0)
//Direction: Either DIRECT or REVERSE. determines which direction the output will move when faced with a given error. DIRECT is most common. --> Reverse
PID myPID(&Input, &Heizstab_soll, &Setpoint,kP,Ki,Kd, REVERSE); // PID aktivieren




void setup() {
	// initialize serial
	Serial.begin(115200); // USB
	Serial1.begin(9600, SERIAL_8E1); // Modbus
	Serial2.begin(115200); // BMS
	Serial3.begin(19200); // LR
	// set the data rate for the SoftwareSerial port
    mySerial1.begin(9600);
    mySerial2.begin(9600);
	// digitale Pins
	pinMode(MAX485_Modbus, OUTPUT);
	pinMode(MAX485_WR, OUTPUT);
	pinMode(MOSFET_WR1, OUTPUT);
	pinMode(MOSFET_WR2, OUTPUT);
	pinMode(MOSFET_WR3, OUTPUT);
	pinMode(MOSFET_Luefter, OUTPUT);
	pinMode(LR_Multiplexer, OUTPUT);
	pinMode(PWM_Heizstab, OUTPUT);
	pinMode(Relais_Heizstab, OUTPUT);
	digitalWrite(MAX485_WR, HIGH);
	
    pinMode(taster, INPUT); //Volleinspeisung ja/nein
	
	// ADS1115
	ads.begin();

	// PID
	myPID.SetMode(AUTOMATIC);//PID aktivieren
	//SetOutputLimits(min, max)
	//min: Low end of the range. must be < max (double)
	//max: High end of the range. must be > min (double) 
//	myPID.SetOutputLimits(0, Heizstab_soll_max);//PID aktivieren
	//Determines how often the PID algorithm evaluates. 
	//The default is 200mS. For robotics applications this may need to be faster, 
	//but for the most part 200mS is plenty fast. 
	myPID.SetSampleTime(1000);//PID aktivieren//200
	 // start serial port

	// reserve 200 bytes for the inputString_BMS:
  	inputString_BMS.reserve(200);



 

}
