void battState() {

	const unsigned long interval_battState = 1000;
	const unsigned long interval_relais_aus = 15000;
	const unsigned long interval_Mosfet_aus = 259200000; // 3 Tage = 259200000; 4 Tage = 345600000

	static unsigned long previousMillis_battState = 0;
	static unsigned long previousMillis_relais_aus = 0;
	static unsigned long previousMillis_Mosfet_aus = 0;
	
	bool MOSFETState;
	bool wr_abschalt = 0;
	bool funkmodul_ein = 0;

	//Mittelwertbildung für Abschaltkriterium Überschussverbraucher
	const byte numReadings = 8;
	static byte index = 0;                  // the index of the current reading
	static long total = 0;                 // the running total
	static long readings[numReadings];      // the readings from the analog input
	long i_bat_mittel;
	
	if (millis() - previousMillis_battState > interval_battState) {
		// Batteriestatus  
		// leer   
		if (u_bat < 27900) bat_leer = 1; // if (u_bat_LR1 < 23200) bat_leer = 1;
		if (u_bat > 29250) bat_leer = 0; // vorher 24500
	
		// Einschaltkriterium für Überschussverwertung
		if ((CS_LR1 >= 4)|| (CS_LR2 >= 4)) bat_voll = 1; 
					//else bat_voll = 0; // (u_bat_LR1 >= 28300) bat_voll = 1; // d.h. bulk Phase vorbei (Istzustand: Absorption oder Float)und nicht aller vom Panel gelieferter Strom wird mehr in der Batterie gespeichert
					// (u_bat_LR1 < 26900) bat_voll = 0; //d.h. float phase vorbei, batterie wird entladen
		
		// Ausschaltkriterium für Überschussverwertung

		total -= readings[index];
		readings[index] = i_bat;
		total += readings[index];
		i_bat_mittel = total / numReadings;

		if (i_bat_mittel < -1000) bat_voll = 0;//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	
		//Heizstabfreigabe über Mosfet und Relais
		if (bat_voll && soc > 90 && tempBoiler < 90) heizstab_ein = 1; // 
		else heizstab_ein = 0; // Heizstab komplett deaktivieren wenn Batterie nicht voll


		// WR-Abschaltung im Winter oder in Schlechwetterphasen (wenn länger nicht CS 5 = Float erreicht wurde)
		if (CS_LR1 == 5) previousMillis_Mosfet_aus = millis();  // Zeitpunkt der letzten Float-Phase speichern
			
		if (millis() - previousMillis_Mosfet_aus > interval_Mosfet_aus) wr_abschalt = 1;
		else wr_abschalt = 0;
		
		// Steuerung WR-MOSFET und Heizstab-Relais
		if ((wr_abschalt == 1) || (bat_leer == 1)) {             
			sendPowerAESGI4(0); // wenn bat_leer=1 wird WR weiter unten im Code nicht mehr geregelt
			heizstab_ein = 0;  // Heizstab komplett abschalten
			if (millis() - previousMillis_relais_aus > interval_relais_aus) MOSFETState = LOW;  //Mosfet ein-/ausschalten, um WR komplett von System zu trennen,
			else MOSFETState = HIGH; //warten bis Intervall zur harten Abschaltung abgelaufen ist
		}
		else {
			MOSFETState = HIGH; //Relais einschalten 
			
			previousMillis_relais_aus = millis();
		}
		
		digitalWrite(MOSFET_WR1, MOSFETState);
		//MOSFET für WR2 parallel zu WR1 schalten
		//digitalWrite(MOSFET_WR3, MOSFETState);
		
		//2. WR nachts und bei kleiner Einstrahlung abschalten
		//if (MOSFETState && PPV_LR1_2 >= 200) digitalWrite(MOSFET_WR3, MOSFETState);
		//if (PPV_LR1_2 <= 10) digitalWrite(MOSFET_WR3, LOW);

	    //Mosfet ansteuern, um Relais für Heizstabversorgung an und auszuschalten
		digitalWrite(MOSFET_WR2, heizstab_ein);
		digitalWrite(Relais_Heizstab, heizstab_ein);

		//Lüfter aktivieren bei hoher Schaltschranktemperatur
		if (tempSchaltschrank >= 50) digitalWrite(MOSFET_Luefter, HIGH);
		
		else digitalWrite(MOSFET_Luefter, LOW);
		
		previousMillis_battState = millis();


	}	
	

				
			
}


			
	
				
