boolean modbus() {

	const byte modbus_request[5][8] = {
		{0x39, 0x03, 0x00, 0x00, 0x00, 0x04, 0x40, 0xB1}, // 0 : grid 1.7.0, 2.7.0  UL1, UL2: {0x39, 0x03, 0x00, 0x04, 0x00, 0x04, 0x01, 0x70}
		{0x39, 0x03, 0x40, 0x00, 0x00, 0x02, 0xD5, 0x73}, // 1 : grid 1.8.0
		{0x39, 0x03, 0x41, 0x00, 0x00, 0x02, 0xD4, 0x8F}, // 2 : grid 2.8.0
		{0x3A, 0x04, 0x00, 0x0C, 0x00, 0x02, 0xB5, 0x43}, // 3 : pv 2.7.0
		{0x3A, 0x04, 0x00, 0x4A, 0x00, 0x02, 0x54, 0x96}  // 4 : pv 2.8.0
	};

	static unsigned long modbus_next_request = 0;
	static byte modbus_request_counter = 0;
	static byte modbus_response_counter = 0;
	static byte inputArray[13];
  
	if (modbus_next_request < millis()) {
		digitalWrite(MAX485_Modbus, 1);
		for (int j = 0; j <= 7; j++) {
			Serial1.write(modbus_request[modbus_request_counter][j]);
		}
		modbus_response_counter = 0;
		modbus_next_request += 5000;
		Serial1.flush();
		digitalWrite(MAX485_Modbus, 0);
	}
	
	while (Serial1.available()) {
		inputArray[modbus_response_counter] = Serial1.read();   
		modbus_response_counter++;
	}
	
	if (modbus_response_counter == modbus_request[modbus_request_counter][5] * 2 + 5) {
		if (inputArray[0] == modbus_request[modbus_request_counter][0] && inputArray[1] == modbus_request[modbus_request_counter][1] && inputArray[2] == modbus_request[modbus_request_counter][5] * 2) {
			// TODO: CRC check
	
			switch (modbus_request_counter) {
				case 0:
					power = (float)((int32_t)byte_to_uint32(inputArray, 3) - (int32_t)byte_to_uint32(inputArray, 7)) / 10;
					break;
				case 1:
					Netz_Bezug = (float)byte_to_uint32(inputArray, 3) / 1000;
					break;
				case 2:
					Netz_Einspeisung = (float)byte_to_uint32(inputArray, 3) / 1000;
					break;
				case 3:
					PV_Leistung = - byte_to_float(inputArray, 3);
					break;
				case 4:
					PV_Einspeisung = byte_to_float(inputArray, 3); 
					break;        
			}
			modbus_response_counter = 0;
			modbus_request_counter++;
			if (modbus_request_counter > 4) {
				modbus_request_counter = 0;
				modbus_next_request = millis() + 2000;
				return true;
			}
			else modbus_next_request = millis() + 50;
		}
	}
	return false;
}


uint32_t byte_to_uint32(byte byteArray[], byte pos) {
	byte b[4];
	uint32_t result;
	for (byte i = 0; i <= 3; i++) b[i] = byteArray[pos + 3 - i];
	memcpy(&result, b, 4);
	return result;
}


float byte_to_float(byte byteArray[], byte pos) {
	byte b[4];
	float result;
	for (byte i = 0; i <= 3; i++) b[i] = byteArray[pos + 3 - i];
	memcpy(&result, b, 4);
	return result;
}
