void send_raspberry() {

	// Zeilen an Raspberry senden
	// Beginn Nachricht (entscheidend für Erkennung ist vermutlich der Schrägstrich)
	Serial.println("/ESY5Q3DA1024 V3.04");

	// Batterie Spannung von Laderegler 1
	Serial.print("1-2:12.7.0*255(");
	Serial.print(u_bat_LR1);
	Serial.println("*mV)");
	
	// Batterie Spannung von Laderegler 2
	Serial.print("1-3:12.7.0*255(");
	Serial.print(u_bat_LR2);
	Serial.println("*mV)");
	
	// Laderegler 1 Erzeugung
	Serial.print("1-2:2.8.0*255(");
	Serial.print(yield_total_LR1);
	Serial.println("*kWh)");
	
	// Laderegler 2 Erzeugung
	Serial.print("1-3:2.8.0*255(");
	Serial.print(yield_total_LR2);
	Serial.println("*kWh)");
	
	// Batteriestrom (BMS)
	 Serial.print("1-5:11.7.0*255(");
	 Serial.print(i_bat);
	 Serial.println("*mA)");

	// Batteriespannung (BMS)
	Serial.print("1-5:12.7.0*255(");
	Serial.print(u_bat);
	Serial.println("*mV)");
	
	// Laderegler 1 Leistung
	Serial.print("1-2:2.7.0*255(");
	Serial.print(PV_Power_LR1);
	Serial.println("*W)");
	
	// Laderegler 2 Leistung
	Serial.print("1-3:2.7.0*255(");
	Serial.print(PV_Power_LR2);
	Serial.println("*W)");
	
	// Laderegler Summe Leistung
	Serial.print("1-4:2.7.0*255(");
	Serial.print(PPV_LR1_2);
	Serial.println("*W)");
	
	// Laderegler 1 Ladestrom
	Serial.print("1-2:11.7.0*255(");
	Serial.print(PV_i_LR1);
	Serial.println("*A)");
	
	// Laderegler 2 Ladestrom
	Serial.print("1-3:11.7.0*255(");
	Serial.print(PV_i_LR2);
	Serial.println("*A)");
	
	// Laderegler Summe Erzeugung
	Serial.print("1-4:2.8.0*255(");
	Serial.print(yield_total_LR1_2);
	Serial.println("*kWh)");
	
	// Laderegler Summe Ladestrom
	Serial.print("1-4:11.7.0*255(");
	Serial.print(PV_i_LR1_2);
	Serial.println("*A)");
	
	// Ladestatus Laderegler1
	Serial.print("1-2:15.11.0*255(");
	Serial.print(CS_LR1);
	Serial.println("*0)");
	
	// Ladestatus Laderegler2
	Serial.print("1-3:15.11.0*255(");
	Serial.print(CS_LR2);
	Serial.println("*0)");

if (ERR_LR1 > 0) {
	// Errorstatus Laderegler1
	Serial.print("1-2:16.11.0*255(");
	Serial.print(ERR_LR1);
	Serial.println("*0)");
}

if (ERR_LR2 > 0) {
	// Errorstatus Laderegler2
	Serial.print("1-3:16.11.0*255(");
	Serial.print(ERR_LR2);
	Serial.println("*0)");
}
	// Heizstabansteuerung Vorgabewert
	Serial.print("1-4:16.12.0*255(");
	Serial.print(Heizstab_soll);
	Serial.println("*0)");
	
	// Leistung Zweirichtungszähler
	Serial.print("1-0:1.7.0*255(");
	Serial.print(power, 1);
	Serial.println("*W)");
	
	// Bezug Zweirichtungszähler
	Serial.print("1-0:1.8.0*255(");
	Serial.print(Netz_Bezug, 3);
	Serial.println("*kWh)");
	
	// Einspeisung Zweirichtungszähler
	Serial.print("1-0:2.8.0*255(");
	Serial.print(Netz_Einspeisung, 3);
	Serial.println("*kWh)");
	
	// Leistung PV
	Serial.print("1-1:2.7.0*255(");
	Serial.print(PV_Leistung, 1);
	Serial.println("*W)");
	
	// Einspeisung PV
	Serial.print("1-1:2.8.0*255(");
	Serial.print(PV_Einspeisung, 3);
	Serial.println("*kWh)");

	// Temperatur Schaltschrank
	Serial.print("9-1:1.0.0*255(");
	Serial.print(tempSchaltschrank, 2);
	Serial.println("*C)");

	// Temperatur Boiler
	Serial.print("9-2:1.0.0*255(");
	Serial.print(tempBoiler, 2);
	Serial.println("*C)");

	// WR Sollwert P
	Serial.print("1-9:2.7.0*255(");
	Serial.print(P_WR_soll);
	Serial.println("*W)");

  // WR Sollwert I
  Serial.print("1-9:11.7.0*255(");
  Serial.print(I_WR_soll, 1);
  Serial.println("*A)");
  
	// Ende Nachricht
	Serial.println("!");

	
}


void debug(){

	const unsigned long intervalLOG = 2000;
	
	static unsigned long previousMillisLOG;
	
	if (millis() - previousMillisLOG > intervalLOG) {
		
//		Serial.print("   P_WR  ");
//		Serial.print(P_WR);
//		Serial.print("   u_bat_LR2  ");
//		Serial.println(u_bat_LR2);
//		Serial.print("  kalibrieren ");
//		Serial.print(kalibrieren);
//		Serial.print("   PPV  ");
//		Serial.print(PPV_LR1_2);
//		Serial.print("    bat_leer ");
//		Serial.print(bat_leer);
//		Serial.print("  bat_voll ");
//		Serial.print(bat_voll);
//		Serial.print("   Heizstab_aus  ");
//		Serial.print(heizstab_aus);
//		Serial.print("   Heizstab_soll  ");
//		Serial.print(Heizstab_soll);
//		Serial.print("  i_bat ");
//		Serial.println(i_bat);
//		Serial.print("  CS_LR1 ");
//		Serial.println(CS_LR1);
//		Serial.print("  CS_LR2 ");
//		Serial.println(CS_LR2);
//		Serial.print("  power ");
//		Serial.print(power);
//		Serial.print(" adc0 ");
//		Serial.print(adc0);
//		Serial.print("  i_bat_ist_Heizstab  ");
//		Serial.print(i_bat);
//		Serial.print("  i_bat_soll_Heizstab  ");
//		Serial.println(i_bat_soll_Heizstab);
//		Serial.print("   Heizstab_ein  ");
//		Serial.println(heizstab_ein);
//		Serial.print("   u_bat_soll  ");
//		Serial.println(u_bat_soll);
//		Serial.print("   Setpoint  ");
//		Serial.println(Setpoint);
//		Serial.print("   Heizstab_soll  ");
//		Serial.println(Heizstab_soll);
//		Serial.print("   Heizstab_soll  ");
//		Serial.println(Heizstab_soll);
		 
		previousMillisLOG = millis();   // aktuelle Zeit abspeichern
	}
}
