// Regelstrategie für WR

void calcPower() {

	const int P_bat_max = 250;//
	const int P_wr_max = 300;
	const float hysterese_WR = 3;//in [W]

	int P_WR = 0;
	
	if  ((bat_leer == 0)) {

			if (power >= 0 + hysterese_WR || power <= 0) {
				
				P_WR = PV_Leistung + power;
	
				if (PPV_LR1_2 > 0) {       //Tagsüberregelung, Batterie bis max P_bat_max belasten//vorher 24500
					if (P_WR > (PPV_LR1_2 + P_bat_max)) P_WR = PPV_LR1_2 + P_bat_max;
				}

				/*
				if (PPV_LR1_2 > 0 && yield_today_LR1 < 10)   {  // if (yield_today_LR1 <= 10) {    //Morgenstundenproblematik bei schwacher Batteriespannung Batterie nicht belasten
					if (P_WR > PPV_LR1_2) P_WR = PPV_LR1_2;
				}
				*/
	
				if (PPV_LR1_2 == 0) {             //Nachtstundenentladung
					if (P_WR > P_bat_max)P_WR = P_bat_max;
				}


				//Schalter zur Volleinspeisung (keine Wechselrichtereinspeisung orientiert am Hausverbrauch) aktiviert (=High) wurde. Gesamte PV Leistung bzw. so viel wie WR maximal kann geht ins Netz 
				
				tasterstatus = digitalRead(taster);
				if (tasterstatus == HIGH)
				{
				int PPV = PPV_LR1_2 * 0.95; //Berücksichtigung WR Wirkungsgrad 
				if ((P_WR < PPV) && (soc >= 65)) { //das ist der Fall wenn PPV_LR1_2 > 0, da Akku noch geladen wird
				P_WR =  PPV;
				}
				}
	
				sendPowerAESGI4(P_WR);				
			}	
	}
}


// Funktion  sendet eine Befehlsabfolge an die Wechselrichter, um diese in der Leistung zu steuern. 
//beide WR werden über das herkömmliche Protokoll im MPP Modus reguliert
void sendPower(int P_WR_temp) {

	const int P_WR1_max = 330;//330
	const int P_WR2_max = 240;
	const int P_WR1_min = 0;
	const int P_WR2_min = 0;
	//{33, 4, 63, 3, 254, 0, 74, 0, 0, 0, 13}  AESGI-Nummer über Communication Test im AE Conversion Programm: 32
	byte message1 [] = {0x21, 0x04, 0x3F, 0x03, 0xFE, 0x00, 0x4A, 0x00, 0x00, 0x00, 0x0D};
	//{33, 0, 68, 3, 254, 0, 74, 0, 0, 0, 13}
	byte message2 [] = {0x21, 0x00, 0x44, 0x03, 0xFE, 0x00, 0x4A, 0x00, 0x00, 0x00, 0x0D};
	int checksum;
	int P_WR1_temp; 
	int P_WR2_temp;

	if (P_WR_temp > P_WR1_max) {
		P_WR1_temp = P_WR1_max;
		P_WR2_temp = P_WR_temp - P_WR1_max;
	}
	else {
		P_WR1_temp = P_WR_temp;
		P_WR2_temp = P_WR2_min;
	}

	// Plausibilitätskontrolle
	if (P_WR2_temp > P_WR2_max) P_WR2_temp = P_WR2_max;
	if (P_WR1_temp < P_WR1_min) P_WR1_temp = P_WR1_min;
	if (P_WR2_temp < P_WR2_min) P_WR2_temp = P_WR2_min;

	message1[5] = P_WR1_temp >> 8;
	message1[6] = P_WR1_temp & 0x00FF;

	message2[5] = P_WR2_temp >> 8;
	message2[6] = P_WR2_temp & 0x00FF;

	// Checksumme für WR1 berechnen
	checksum = 0;
	for (int i = 1; i <= 8; i++) {
		checksum = checksum ^ message1[i];
	}
	message1[9] = checksum;

	// Checksumme für WR2 berechnen
	checksum = 0;
	for (int i = 1; i <= 8; i++) {
		checksum = checksum ^ message2[i];
	}
	message2[9] = checksum;

	for (int j = 0; j <= 10; j++) {
		Serial2.write(message1[j]);
	}
	for (int j = 0; j <= 10; j++) {
	Serial2.write(message2[j]);
	}
}

//Thomas' WR wird über das AESGI Protokoll im Batterie- Modus reguliert

void sendPowerAESGI(int P_WR_temp) {

	const int P_WR1_max = 330;//330
	const int P_WR2_max = 240;
	const int P_WR1_min = 0;
	const int P_WR2_min = 0;

	int P_WR1_temp; 
	int P_WR2_temp;
	float I_WR1;
	
	if (P_WR_temp > P_WR1_max) {
		P_WR1_temp = P_WR1_max;
		P_WR2_temp = P_WR_temp - P_WR1_max;
	}
	else {
		P_WR1_temp = P_WR_temp;
		P_WR2_temp = P_WR2_min;
	}

	// Plausibilitätskontrolle
	if (P_WR2_temp > P_WR2_max) P_WR2_temp = P_WR2_max;
	if (P_WR1_temp < P_WR1_min) P_WR1_temp = P_WR1_min;
	if (P_WR2_temp < P_WR2_min) P_WR2_temp = P_WR2_min;
	
	//Umrechnung Leistung in Strom
	I_WR1 = P_WR1_temp / u_bat * 1000;
	constrain(I_WR1, 0, 11.5);
	//I_WR1 = 2;
	digitalWrite(MAX485_WR, HIGH);
	Serial2.println("#32B 2 23.0");
	Serial2.print("#32S ");
	if (I_WR1 < 10) Serial2.print("0");
	Serial2.println(I_WR1, 1);
	Serial2.flush();
	
	digitalWrite(MAX485_WR, LOW);
	
}


//Thomas' WR wird über das AESGI Protokoll im Batterie- Modus reguliert über Hardware Serial
//Simons WR im MPP Modus reguliert über Software Serial


void sendPowerAESGI2(int P_WR_temp) {

	const int P_WR1_max = 50;//330//20
	const int P_WR2_max = 240;//100
	const int P_WR1_min = 0;
	const int P_WR2_min = 0;

	//{33, 4, 63, 3, 254, 0, 74, 0, 0, 0, 13}  AESGI-Nummer über Communication Test im AE Conversion Programm: 32
	byte message1 [] = {0x21, 0x04, 0x3F, 0x03, 0xFE, 0x00, 0x4A, 0x00, 0x00, 0x00, 0x0D};
	//{33, 0, 68, 3, 254, 0, 74, 0, 0, 0, 13}
	byte message2 [] = {0x21, 0x00, 0x44, 0x03, 0xFE, 0x00, 0x4A, 0x00, 0x00, 0x00, 0x0D};
	int checksum;

	int P_WR1_temp; 
	int P_WR2_temp;
	float I_WR1;
	
	if (P_WR_temp > P_WR1_max) {
		P_WR1_temp = P_WR1_max;
		P_WR2_temp = P_WR_temp - P_WR1_max;
	}
	else {
		P_WR1_temp = P_WR_temp;
		P_WR2_temp = P_WR2_min;
	}

	// Plausibilitätskontrolle
	if (P_WR2_temp > P_WR2_max) P_WR2_temp = P_WR2_max;
	if (P_WR1_temp < P_WR1_min) P_WR1_temp = P_WR1_min;
	if (P_WR2_temp < P_WR2_min) P_WR2_temp = P_WR2_min;
	
	//Umrechnung Leistung in Strom
	I_WR1 = P_WR1_temp / u_bat * 1000;
	constrain(I_WR1, 0, 11.5);
	//Übertragung der Regelwerte über AESGI Protokoll an WR 1
	digitalWrite(MAX485_WR, HIGH);
	Serial2.println("#32B 2 23.0");
	Serial2.print("#32S ");
	if (I_WR1 < 10) Serial2.print("0");
	Serial2.println(I_WR1, 1);
	Serial2.flush();
	
	digitalWrite(MAX485_WR, LOW);

	// Leistung WR2 setzen (Binärprotokoll)
	// Umrechnung in Binärwert
	message2[5] = P_WR2_temp >> 8;
	message2[6] = P_WR2_temp & 0x00FF;

	// Checksumme für WR2 berechnen
	checksum = 0;
	for (int i = 1; i <= 8; i++) {
		checksum = checksum ^ message2[i];
	}
	message2[9] = checksum;

	// Übertragung
	//digitalWrite(MAX485_WR, HIGH);
	for (int j = 0; j <= 10; j++) {
		mySerial1.write(message2[j]);
	}
	mySerial1.flush();
	//digitalWrite(MAX485_WR, LOW);
}

//Thomas' WR wird über das AESGI Protokoll im Batterie- Modus reguliert über Software Serial
//Simons WR im MPP Modus reguliert über Software Serial

void sendPowerAESGI3(int P_WR_temp) {

	const int P_WR1_max = 330;//330
	const int P_WR2_max = 330;
	const int P_WR1_min = 0;
	const int P_WR2_min = 0;

	int P_WR1_temp; 
	int P_WR2_temp;
	float I_WR1;
	
	if (P_WR_temp > P_WR1_max) {
		P_WR1_temp = P_WR1_max;
		P_WR2_temp = P_WR_temp - P_WR1_max;
	}
	else {
		P_WR1_temp = P_WR_temp;
		P_WR2_temp = P_WR2_min;
	}

	// Plausibilitätskontrolle
	if (P_WR2_temp > P_WR2_max) P_WR2_temp = P_WR2_max;
	if (P_WR1_temp < P_WR1_min) P_WR1_temp = P_WR1_min;
	if (P_WR2_temp < P_WR2_min) P_WR2_temp = P_WR2_min;
	
	//Umrechnung Leistung in Strom
	I_WR1 = P_WR1_temp / u_bat * 1000;
	constrain(I_WR1, 0, 11.0);
	//I_WR1 = 2;
	digitalWrite(MAX485_WR, HIGH);
	Serial2.println("#32B 2 23.0");
	Serial2.print("#32S ");
	if (I_WR1 < 10) Serial2.print("0");
	Serial2.println(I_WR1, 1);
	Serial2.flush();
	
	digitalWrite(MAX485_WR, LOW);
	
}


void sendPowerAESGI4(int P_WR_temp) {
	
	const unsigned long intervalWR = 5000;   //10000
	static unsigned long previousMillisWR = 0;
	
	const int P_WR1_max = 330;//280
	const int P_WR2_max = 240;//240
	const int P_WR1_min = 0;
	const int P_WR2_min = 0;

	//{33, 4, 63, 3, 254, 0, 74, 0, 0, 0, 13}  AESGI-Nummer über Communication Test im AE Conversion Programm: 32
	byte message1 [] = {0x21, 0x04, 0x3F, 0x03, 0xFE, 0x00, 0x4A, 0x00, 0x00, 0x00, 0x0D};
	//{33, 0, 68, 3, 254, 0, 74, 0, 0, 0, 13}
	byte message2 [] = {0x21, 0x00, 0x44, 0x03, 0xFE, 0x00, 0x4A, 0x00, 0x00, 0x00, 0x0D};
	int checksum;
	
	int P_WR1_temp; 
	int P_WR2_temp;
	float I_WR1;
	
	if (millis() - previousMillisWR > intervalWR) {
	
		if (P_WR_temp > P_WR1_max) {
			P_WR1_temp = P_WR1_max;
			P_WR2_temp = P_WR_temp - P_WR1_max;
		}
		else {
			P_WR1_temp = P_WR_temp;
			P_WR2_temp = P_WR2_min;
		}

		// Plausibilitätskontrolle
		if (P_WR2_temp > P_WR2_max) P_WR2_temp = P_WR2_max;
		if (P_WR1_temp < P_WR1_min) P_WR1_temp = P_WR1_min;
		if (P_WR2_temp < P_WR2_min) P_WR2_temp = P_WR2_min;

		P_WR_soll = P_WR1_temp;
	
		// Leistung WR1 setzen (AESGI Protokoll)
	
		//Umrechnung Leistung in Strom
		I_WR1 = u_bat > 25000 ? (float)P_WR1_temp / u_bat * 1000 * 1.06 : 0;
		I_WR1 = constrain(I_WR1, 0, 10.5);
        I_WR_soll = I_WR1;
		digitalWrite(MAX485_WR, HIGH);
		mySerial2.println("#32B 2 27.0");
		mySerial2.print("#32S ");
		if (I_WR1 < 10) mySerial2.print("0");
		mySerial2.println(I_WR1, 1);
		mySerial2.flush();
		digitalWrite(MAX485_WR, LOW);

		previousMillisWR = millis();
	}
}
